package service

import (
	"fmt"
	"iot_manager_service/app/device/dao"
	"iot_manager_service/app/device/model"
	"iot_manager_service/app/system/service"
	"iot_manager_service/util/cache"
	"iot_manager_service/util/common"
	"iot_manager_service/util/logger"
	"time"
)

var TransformerService = new(transformerService)

type transformerService struct{}

func (s *transformerService) Get(id int) (*dao.Transformer, *common.Errors) {
	// 创建查询实例
	device := &dao.Transformer{
		ID: id,
	}
	err := device.GetDevice()
	if err != nil {
		return nil, common.FailResponse(err.Error(), nil)
	}
	return device, nil

}

func (s *transformerService) CreateOrUpdate(userId int64, tenantId string, req dao.Transformer) *common.Errors {
	// 创建查询实例
	device := req
	device.TenantId = tenantId
	device.UpdateUser = userId
	device.UpdateTime = time.Now()
	if req.ID == 0 {
		device.CreateTime = time.Now()
		device.CreateUser = userId
		if device.IsExistedBySN() {
			logger.Logger.Errorf("Create GetDeviceID err \n")
			return common.ParamsInvalidResponse("编码不能重复，请重新填写！", nil)
		}
		if err := device.Create(); err != nil {
			logger.Logger.Errorf("Create err = %s \n", err.Error())
			return common.FailResponse(err.Error(), nil)
		}
		service.OperationHisService.Save(userId, tenantId, common.OperationCreate, common.ModuleTypeDevice,
			common.DeviceTypeTransformer, common.GetDeviceObject(device.ID, device.TransName), common.OperationSuccess)
		return common.SuccessResponse(common.Succeeded, nil)
	}
	if device.IsExistedByNameAndCode() {
		return common.ParamsInvalidResponse("编码不能重复，请重新填写！", nil)
	}

	if err := device.Update(); err != nil {
		logger.Logger.Errorf("Update err = %s \n", err.Error())
		return common.FailResponse(err.Error(), nil)
	}

	service.OperationHisService.Save(userId, tenantId, common.OperationUpdate, common.ModuleTypeDevice,
		common.DeviceTypeTransformer, common.GetDeviceObject(device.ID, device.TransName), common.OperationSuccess)
	return common.SuccessResponse(common.Succeeded, nil)
}

func (s *transformerService) List(searchValue string, current, size int) ([]dao.Transformer, int64, *common.Errors) {
	device := dao.Transformer{}
	if searchValue != "" {
		device.TransSN = searchValue
		device.TransName = searchValue
	}

	offset := (current - 1) * size
	limit := size
	devices, total, err := device.GetDevices(offset, limit)
	if err != nil {
		return nil, 0, common.FailResponse(err.Error(), nil)
	}

	for i, transformer := range devices {
		switchBox := dao.SwitchBox{TransformerId: transformer.ID}
		devices[i].CountNum, _ = switchBox.GetDeviceCount()
	}
	return devices, total, nil
}

func (s *transformerService) Remove(userId int64, tenantId string, id int) *common.Errors {
	// 创建查询实例
	device := &dao.Transformer{
		ID:         id,
		IsDeleted:  1,
		UpdateUser: userId,
		UpdateTime: time.Now(),
	}
	err := device.Delete()
	if err != nil {
		return common.FailResponse(err.Error(), nil)
	}
	service.OperationHisService.Save(userId, tenantId, common.OperationRemove, common.ModuleTypeDevice,
		common.DeviceTypeTransformer, common.GetDeviceObject(device.ID, device.TransName), common.OperationSuccess)
	return nil
}

func (s *transformerService) GetList(tenantId string, ) ([]*dao.Transformer, *common.Errors) {
	var devices []*dao.Transformer
	err := cache.Redis.Get(getTransformerListRedisKey(tenantId)).Scan(&devices)
	if err == nil {
		return devices, nil
	}

	device := &dao.Transformer{
		TenantId:  tenantId,
		IsDeleted: 0,
	}
	devices, err = device.GetAllDevices()
	if err != nil {
		return nil, common.FailResponse(err.Error(), nil)
	}
	_ = cache.Redis.Set(getTransformerListRedisKey(tenantId), devices, 0).Err()

	return devices, nil
}

func getTransformerListRedisKey(tenantId string, ) string {
	return fmt.Sprintf(model.TransformerList, tenantId)
}
